<?php

namespace eBizCharge\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCardExpirationCounts ArrayType
 * @subpackage Arrays
 */
class ArrayOfCardExpirationCounts extends AbstractStructArrayBase
{
    /**
     * The CardExpirationCounts
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \eBizCharge\StructType\CardExpirationCounts[]
     */
    public $CardExpirationCounts;
    /**
     * Constructor method for ArrayOfCardExpirationCounts
     * @uses ArrayOfCardExpirationCounts::setCardExpirationCounts()
     * @param \eBizCharge\StructType\CardExpirationCounts[] $cardExpirationCounts
     */
    public function __construct(array $cardExpirationCounts = array())
    {
        $this
            ->setCardExpirationCounts($cardExpirationCounts);
    }
    /**
     * Get CardExpirationCounts value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \eBizCharge\StructType\CardExpirationCounts[]|null
     */
    public function getCardExpirationCounts()
    {
        return isset($this->CardExpirationCounts) ? $this->CardExpirationCounts : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCardExpirationCounts method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCardExpirationCounts method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCardExpirationCountsForArrayConstraintsFromSetCardExpirationCounts(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCardExpirationCountsCardExpirationCountsItem) {
            // validation for constraint: itemType
            if (!$arrayOfCardExpirationCountsCardExpirationCountsItem instanceof \eBizCharge\StructType\CardExpirationCounts) {
                $invalidValues[] = is_object($arrayOfCardExpirationCountsCardExpirationCountsItem) ? get_class($arrayOfCardExpirationCountsCardExpirationCountsItem) : sprintf('%s(%s)', gettype($arrayOfCardExpirationCountsCardExpirationCountsItem), var_export($arrayOfCardExpirationCountsCardExpirationCountsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CardExpirationCounts property can only contain items of type \eBizCharge\StructType\CardExpirationCounts, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CardExpirationCounts value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\CardExpirationCounts[] $cardExpirationCounts
     * @return \eBizCharge\ArrayType\ArrayOfCardExpirationCounts
     */
    public function setCardExpirationCounts(array $cardExpirationCounts = array())
    {
        // validation for constraint: array
        if ('' !== ($cardExpirationCountsArrayErrorMessage = self::validateCardExpirationCountsForArrayConstraintsFromSetCardExpirationCounts($cardExpirationCounts))) {
            throw new \InvalidArgumentException($cardExpirationCountsArrayErrorMessage, __LINE__);
        }
        if (is_null($cardExpirationCounts) || (is_array($cardExpirationCounts) && empty($cardExpirationCounts))) {
            unset($this->CardExpirationCounts);
        } else {
            $this->CardExpirationCounts = $cardExpirationCounts;
        }
        return $this;
    }
    /**
     * Add item to CardExpirationCounts value
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\CardExpirationCounts $item
     * @return \eBizCharge\ArrayType\ArrayOfCardExpirationCounts
     */
    public function addToCardExpirationCounts(\eBizCharge\StructType\CardExpirationCounts $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \eBizCharge\StructType\CardExpirationCounts) {
            throw new \InvalidArgumentException(sprintf('The CardExpirationCounts property can only contain items of type \eBizCharge\StructType\CardExpirationCounts, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CardExpirationCounts[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \eBizCharge\StructType\CardExpirationCounts|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \eBizCharge\StructType\CardExpirationCounts|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \eBizCharge\StructType\CardExpirationCounts|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \eBizCharge\StructType\CardExpirationCounts|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \eBizCharge\StructType\CardExpirationCounts|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CardExpirationCounts
     */
    public function getAttributeName()
    {
        return 'CardExpirationCounts';
    }
}
