<?php

namespace eBizCharge\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFieldValue ArrayType
 * @subpackage Arrays
 */
class ArrayOfFieldValue extends AbstractStructArrayBase
{
    /**
     * The FieldValue
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \eBizCharge\StructType\FieldValue[]
     */
    public $FieldValue;
    /**
     * Constructor method for ArrayOfFieldValue
     * @uses ArrayOfFieldValue::setFieldValue()
     * @param \eBizCharge\StructType\FieldValue[] $fieldValue
     */
    public function __construct(array $fieldValue = array())
    {
        $this
            ->setFieldValue($fieldValue);
    }
    /**
     * Get FieldValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \eBizCharge\StructType\FieldValue[]|null
     */
    public function getFieldValue()
    {
        return isset($this->FieldValue) ? $this->FieldValue : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFieldValue method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFieldValue method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFieldValueForArrayConstraintsFromSetFieldValue(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFieldValueFieldValueItem) {
            // validation for constraint: itemType
            if (!$arrayOfFieldValueFieldValueItem instanceof \eBizCharge\StructType\FieldValue) {
                $invalidValues[] = is_object($arrayOfFieldValueFieldValueItem) ? get_class($arrayOfFieldValueFieldValueItem) : sprintf('%s(%s)', gettype($arrayOfFieldValueFieldValueItem), var_export($arrayOfFieldValueFieldValueItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FieldValue property can only contain items of type \eBizCharge\StructType\FieldValue, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FieldValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\FieldValue[] $fieldValue
     * @return \eBizCharge\ArrayType\ArrayOfFieldValue
     */
    public function setFieldValue(array $fieldValue = array())
    {
        // validation for constraint: array
        if ('' !== ($fieldValueArrayErrorMessage = self::validateFieldValueForArrayConstraintsFromSetFieldValue($fieldValue))) {
            throw new \InvalidArgumentException($fieldValueArrayErrorMessage, __LINE__);
        }
        if (is_null($fieldValue) || (is_array($fieldValue) && empty($fieldValue))) {
            unset($this->FieldValue);
        } else {
            $this->FieldValue = $fieldValue;
        }
        return $this;
    }
    /**
     * Add item to FieldValue value
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\FieldValue $item
     * @return \eBizCharge\ArrayType\ArrayOfFieldValue
     */
    public function addToFieldValue(\eBizCharge\StructType\FieldValue $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \eBizCharge\StructType\FieldValue) {
            throw new \InvalidArgumentException(sprintf('The FieldValue property can only contain items of type \eBizCharge\StructType\FieldValue, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FieldValue[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \eBizCharge\StructType\FieldValue|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \eBizCharge\StructType\FieldValue|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \eBizCharge\StructType\FieldValue|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \eBizCharge\StructType\FieldValue|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \eBizCharge\StructType\FieldValue|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FieldValue
     */
    public function getAttributeName()
    {
        return 'FieldValue';
    }
}
