<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerTransactionRequest StructType
 * @subpackage Structs
 */
class CustomerTransactionRequest extends AbstractStructBase
{
    /**
     * The isRecurring
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $isRecurring;
    /**
     * The IgnoreDuplicate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IgnoreDuplicate;
    /**
     * The MerchReceipt
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $MerchReceipt;
    /**
     * The CustReceipt
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $CustReceipt;
    /**
     * The InventoryLocation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InventoryLocation;
    /**
     * The Details
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\TransactionDetail
     */
    public $Details;
    /**
     * The MerchReceiptName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MerchReceiptName;
    /**
     * The MerchReceiptEmail
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MerchReceiptEmail;
    /**
     * The Software
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Software;
    /**
     * The CustReceiptName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CustReceiptName;
    /**
     * The CustReceiptEmail
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CustReceiptEmail;
    /**
     * The CustomFields
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\ArrayType\ArrayOfFieldValue
     */
    public $CustomFields;
    /**
     * The ClientIP
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClientIP;
    /**
     * The CardCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CardCode;
    /**
     * The Command
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Command;
    /**
     * The LineItems
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\ArrayType\ArrayOfLineItem
     */
    public $LineItems;
    /**
     * Constructor method for CustomerTransactionRequest
     * @uses CustomerTransactionRequest::setIsRecurring()
     * @uses CustomerTransactionRequest::setIgnoreDuplicate()
     * @uses CustomerTransactionRequest::setMerchReceipt()
     * @uses CustomerTransactionRequest::setCustReceipt()
     * @uses CustomerTransactionRequest::setInventoryLocation()
     * @uses CustomerTransactionRequest::setDetails()
     * @uses CustomerTransactionRequest::setMerchReceiptName()
     * @uses CustomerTransactionRequest::setMerchReceiptEmail()
     * @uses CustomerTransactionRequest::setSoftware()
     * @uses CustomerTransactionRequest::setCustReceiptName()
     * @uses CustomerTransactionRequest::setCustReceiptEmail()
     * @uses CustomerTransactionRequest::setCustomFields()
     * @uses CustomerTransactionRequest::setClientIP()
     * @uses CustomerTransactionRequest::setCardCode()
     * @uses CustomerTransactionRequest::setCommand()
     * @uses CustomerTransactionRequest::setLineItems()
     * @param bool $isRecurring
     * @param bool $ignoreDuplicate
     * @param bool $merchReceipt
     * @param bool $custReceipt
     * @param string $inventoryLocation
     * @param \eBizCharge\StructType\TransactionDetail $details
     * @param string $merchReceiptName
     * @param string $merchReceiptEmail
     * @param string $software
     * @param string $custReceiptName
     * @param string $custReceiptEmail
     * @param \eBizCharge\ArrayType\ArrayOfFieldValue $customFields
     * @param string $clientIP
     * @param string $cardCode
     * @param string $command
     * @param \eBizCharge\ArrayType\ArrayOfLineItem $lineItems
     */
    public function __construct($isRecurring = null, $ignoreDuplicate = null, $merchReceipt = null, $custReceipt = null, $inventoryLocation = null, \eBizCharge\StructType\TransactionDetail $details = null, $merchReceiptName = null, $merchReceiptEmail = null, $software = null, $custReceiptName = null, $custReceiptEmail = null, \eBizCharge\ArrayType\ArrayOfFieldValue $customFields = null, $clientIP = null, $cardCode = null, $command = null, \eBizCharge\ArrayType\ArrayOfLineItem $lineItems = null)
    {
        $this
            ->setIsRecurring($isRecurring)
            ->setIgnoreDuplicate($ignoreDuplicate)
            ->setMerchReceipt($merchReceipt)
            ->setCustReceipt($custReceipt)
            ->setInventoryLocation($inventoryLocation)
            ->setDetails($details)
            ->setMerchReceiptName($merchReceiptName)
            ->setMerchReceiptEmail($merchReceiptEmail)
            ->setSoftware($software)
            ->setCustReceiptName($custReceiptName)
            ->setCustReceiptEmail($custReceiptEmail)
            ->setCustomFields($customFields)
            ->setClientIP($clientIP)
            ->setCardCode($cardCode)
            ->setCommand($command)
            ->setLineItems($lineItems);
    }
    /**
     * Get isRecurring value
     * @return bool
     */
    public function getIsRecurring()
    {
        return $this->isRecurring;
    }
    /**
     * Set isRecurring value
     * @param bool $isRecurring
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setIsRecurring($isRecurring = null)
    {
        // validation for constraint: boolean
        if (!is_null($isRecurring) && !is_bool($isRecurring)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isRecurring, true), gettype($isRecurring)), __LINE__);
        }
        $this->isRecurring = $isRecurring;
        return $this;
    }
    /**
     * Get IgnoreDuplicate value
     * @return bool
     */
    public function getIgnoreDuplicate()
    {
        return $this->IgnoreDuplicate;
    }
    /**
     * Set IgnoreDuplicate value
     * @param bool $ignoreDuplicate
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setIgnoreDuplicate($ignoreDuplicate = null)
    {
        // validation for constraint: boolean
        if (!is_null($ignoreDuplicate) && !is_bool($ignoreDuplicate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($ignoreDuplicate, true), gettype($ignoreDuplicate)), __LINE__);
        }
        $this->IgnoreDuplicate = $ignoreDuplicate;
        return $this;
    }
    /**
     * Get MerchReceipt value
     * @return bool
     */
    public function getMerchReceipt()
    {
        return $this->MerchReceipt;
    }
    /**
     * Set MerchReceipt value
     * @param bool $merchReceipt
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setMerchReceipt($merchReceipt = null)
    {
        // validation for constraint: boolean
        if (!is_null($merchReceipt) && !is_bool($merchReceipt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($merchReceipt, true), gettype($merchReceipt)), __LINE__);
        }
        $this->MerchReceipt = $merchReceipt;
        return $this;
    }
    /**
     * Get CustReceipt value
     * @return bool
     */
    public function getCustReceipt()
    {
        return $this->CustReceipt;
    }
    /**
     * Set CustReceipt value
     * @param bool $custReceipt
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setCustReceipt($custReceipt = null)
    {
        // validation for constraint: boolean
        if (!is_null($custReceipt) && !is_bool($custReceipt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($custReceipt, true), gettype($custReceipt)), __LINE__);
        }
        $this->CustReceipt = $custReceipt;
        return $this;
    }
    /**
     * Get InventoryLocation value
     * @return string|null
     */
    public function getInventoryLocation()
    {
        return $this->InventoryLocation;
    }
    /**
     * Set InventoryLocation value
     * @param string $inventoryLocation
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setInventoryLocation($inventoryLocation = null)
    {
        // validation for constraint: string
        if (!is_null($inventoryLocation) && !is_string($inventoryLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inventoryLocation, true), gettype($inventoryLocation)), __LINE__);
        }
        $this->InventoryLocation = $inventoryLocation;
        return $this;
    }
    /**
     * Get Details value
     * @return \eBizCharge\StructType\TransactionDetail|null
     */
    public function getDetails()
    {
        return $this->Details;
    }
    /**
     * Set Details value
     * @param \eBizCharge\StructType\TransactionDetail $details
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setDetails(\eBizCharge\StructType\TransactionDetail $details = null)
    {
        $this->Details = $details;
        return $this;
    }
    /**
     * Get MerchReceiptName value
     * @return string|null
     */
    public function getMerchReceiptName()
    {
        return $this->MerchReceiptName;
    }
    /**
     * Set MerchReceiptName value
     * @param string $merchReceiptName
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setMerchReceiptName($merchReceiptName = null)
    {
        // validation for constraint: string
        if (!is_null($merchReceiptName) && !is_string($merchReceiptName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($merchReceiptName, true), gettype($merchReceiptName)), __LINE__);
        }
        $this->MerchReceiptName = $merchReceiptName;
        return $this;
    }
    /**
     * Get MerchReceiptEmail value
     * @return string|null
     */
    public function getMerchReceiptEmail()
    {
        return $this->MerchReceiptEmail;
    }
    /**
     * Set MerchReceiptEmail value
     * @param string $merchReceiptEmail
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setMerchReceiptEmail($merchReceiptEmail = null)
    {
        // validation for constraint: string
        if (!is_null($merchReceiptEmail) && !is_string($merchReceiptEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($merchReceiptEmail, true), gettype($merchReceiptEmail)), __LINE__);
        }
        $this->MerchReceiptEmail = $merchReceiptEmail;
        return $this;
    }
    /**
     * Get Software value
     * @return string|null
     */
    public function getSoftware()
    {
        return $this->Software;
    }
    /**
     * Set Software value
     * @param string $software
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setSoftware($software = null)
    {
        // validation for constraint: string
        if (!is_null($software) && !is_string($software)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($software, true), gettype($software)), __LINE__);
        }
        $this->Software = $software;
        return $this;
    }
    /**
     * Get CustReceiptName value
     * @return string|null
     */
    public function getCustReceiptName()
    {
        return $this->CustReceiptName;
    }
    /**
     * Set CustReceiptName value
     * @param string $custReceiptName
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setCustReceiptName($custReceiptName = null)
    {
        // validation for constraint: string
        if (!is_null($custReceiptName) && !is_string($custReceiptName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($custReceiptName, true), gettype($custReceiptName)), __LINE__);
        }
        $this->CustReceiptName = $custReceiptName;
        return $this;
    }
    /**
     * Get CustReceiptEmail value
     * @return string|null
     */
    public function getCustReceiptEmail()
    {
        return $this->CustReceiptEmail;
    }
    /**
     * Set CustReceiptEmail value
     * @param string $custReceiptEmail
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setCustReceiptEmail($custReceiptEmail = null)
    {
        // validation for constraint: string
        if (!is_null($custReceiptEmail) && !is_string($custReceiptEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($custReceiptEmail, true), gettype($custReceiptEmail)), __LINE__);
        }
        $this->CustReceiptEmail = $custReceiptEmail;
        return $this;
    }
    /**
     * Get CustomFields value
     * @return \eBizCharge\ArrayType\ArrayOfFieldValue|null
     */
    public function getCustomFields()
    {
        return $this->CustomFields;
    }
    /**
     * Set CustomFields value
     * @param \eBizCharge\ArrayType\ArrayOfFieldValue $customFields
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setCustomFields(\eBizCharge\ArrayType\ArrayOfFieldValue $customFields = null)
    {
        $this->CustomFields = $customFields;
        return $this;
    }
    /**
     * Get ClientIP value
     * @return string|null
     */
    public function getClientIP()
    {
        return $this->ClientIP;
    }
    /**
     * Set ClientIP value
     * @param string $clientIP
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setClientIP($clientIP = null)
    {
        // validation for constraint: string
        if (!is_null($clientIP) && !is_string($clientIP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientIP, true), gettype($clientIP)), __LINE__);
        }
        $this->ClientIP = $clientIP;
        return $this;
    }
    /**
     * Get CardCode value
     * @return string|null
     */
    public function getCardCode()
    {
        return $this->CardCode;
    }
    /**
     * Set CardCode value
     * @param string $cardCode
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setCardCode($cardCode = null)
    {
        // validation for constraint: string
        if (!is_null($cardCode) && !is_string($cardCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cardCode, true), gettype($cardCode)), __LINE__);
        }
        $this->CardCode = $cardCode;
        return $this;
    }
    /**
     * Get Command value
     * @return string|null
     */
    public function getCommand()
    {
        return $this->Command;
    }
    /**
     * Set Command value
     * @param string $command
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setCommand($command = null)
    {
        // validation for constraint: string
        if (!is_null($command) && !is_string($command)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($command, true), gettype($command)), __LINE__);
        }
        $this->Command = $command;
        return $this;
    }
    /**
     * Get LineItems value
     * @return \eBizCharge\ArrayType\ArrayOfLineItem|null
     */
    public function getLineItems()
    {
        return $this->LineItems;
    }
    /**
     * Set LineItems value
     * @param \eBizCharge\ArrayType\ArrayOfLineItem $lineItems
     * @return \eBizCharge\StructType\CustomerTransactionRequest
     */
    public function setLineItems(\eBizCharge\ArrayType\ArrayOfLineItem $lineItems = null)
    {
        $this->LineItems = $lineItems;
        return $this;
    }
}
