<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetScheduledDatesResponse StructType
 * @subpackage Structs
 */
class GetScheduledDatesResponse extends AbstractStructBase
{
    /**
     * The StatusCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $StatusCode;
    /**
     * The ErrorCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ErrorCode;
    /**
     * The GetScheduledDatesResult
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\GetScheduledDatesResponse
     */
    public $GetScheduledDatesResult;
    /**
     * The ScheduledDates
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ScheduledDates;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Status;
    /**
     * The Error
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Error;
    /**
     * Constructor method for GetScheduledDatesResponse
     * @uses GetScheduledDatesResponse::setStatusCode()
     * @uses GetScheduledDatesResponse::setErrorCode()
     * @uses GetScheduledDatesResponse::setGetScheduledDatesResult()
     * @uses GetScheduledDatesResponse::setScheduledDates()
     * @uses GetScheduledDatesResponse::setStatus()
     * @uses GetScheduledDatesResponse::setError()
     * @param int $statusCode
     * @param int $errorCode
     * @param \eBizCharge\StructType\GetScheduledDatesResponse $getScheduledDatesResult
     * @param string $scheduledDates
     * @param string $status
     * @param string $error
     */
    public function __construct($statusCode = null, $errorCode = null, \eBizCharge\StructType\GetScheduledDatesResponse $getScheduledDatesResult = null, $scheduledDates = null, $status = null, $error = null)
    {
        $this
            ->setStatusCode($statusCode)
            ->setErrorCode($errorCode)
            ->setGetScheduledDatesResult($getScheduledDatesResult)
            ->setScheduledDates($scheduledDates)
            ->setStatus($status)
            ->setError($error);
    }
    /**
     * Get StatusCode value
     * @return int
     */
    public function getStatusCode()
    {
        return $this->StatusCode;
    }
    /**
     * Set StatusCode value
     * @param int $statusCode
     * @return \eBizCharge\StructType\GetScheduledDatesResponse
     */
    public function setStatusCode($statusCode = null)
    {
        // validation for constraint: int
        if (!is_null($statusCode) && !(is_int($statusCode) || ctype_digit($statusCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusCode, true), gettype($statusCode)), __LINE__);
        }
        $this->StatusCode = $statusCode;
        return $this;
    }
    /**
     * Get ErrorCode value
     * @return int
     */
    public function getErrorCode()
    {
        return $this->ErrorCode;
    }
    /**
     * Set ErrorCode value
     * @param int $errorCode
     * @return \eBizCharge\StructType\GetScheduledDatesResponse
     */
    public function setErrorCode($errorCode = null)
    {
        // validation for constraint: int
        if (!is_null($errorCode) && !(is_int($errorCode) || ctype_digit($errorCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($errorCode, true), gettype($errorCode)), __LINE__);
        }
        $this->ErrorCode = $errorCode;
        return $this;
    }
    /**
     * Get GetScheduledDatesResult value
     * @return \eBizCharge\StructType\GetScheduledDatesResponse|null
     */
    public function getGetScheduledDatesResult()
    {
        return $this->GetScheduledDatesResult;
    }
    /**
     * Set GetScheduledDatesResult value
     * @param \eBizCharge\StructType\GetScheduledDatesResponse $getScheduledDatesResult
     * @return \eBizCharge\StructType\GetScheduledDatesResponse
     */
    public function setGetScheduledDatesResult(\eBizCharge\StructType\GetScheduledDatesResponse $getScheduledDatesResult = null)
    {
        $this->GetScheduledDatesResult = $getScheduledDatesResult;
        return $this;
    }
    /**
     * Get ScheduledDates value
     * @return string|null
     */
    public function getScheduledDates()
    {
        return $this->ScheduledDates;
    }
    /**
     * Set ScheduledDates value
     * @param string $scheduledDates
     * @return \eBizCharge\StructType\GetScheduledDatesResponse
     */
    public function setScheduledDates($scheduledDates = null)
    {
        // validation for constraint: string
        if (!is_null($scheduledDates) && !is_string($scheduledDates)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($scheduledDates, true), gettype($scheduledDates)), __LINE__);
        }
        $this->ScheduledDates = $scheduledDates;
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \eBizCharge\StructType\GetScheduledDatesResponse
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get Error value
     * @return string|null
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * Set Error value
     * @param string $error
     * @return \eBizCharge\StructType\GetScheduledDatesResponse
     */
    public function setError($error = null)
    {
        // validation for constraint: string
        if (!is_null($error) && !is_string($error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($error, true), gettype($error)), __LINE__);
        }
        $this->Error = $error;
        return $this;
    }
}
